﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using VillainmadEngine;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace Villainmad.Stages
{
    class EntityBall : GameEntity
    {
        //*
        private static Animation anim = 
            new Animation("Sprites/bulOrbSheet", 15, new Rectangle[]{
            new Rectangle(0, 0, 16, 16),
            new Rectangle(16, 0, 16, 16),
            new Rectangle(32, 0, 16, 16),
            new Rectangle(48, 0, 16, 16),
        });//*/

        private static Color RedColor = new Color(1F, 0.5f, 0.5f);
        private Color curColor = Color.White;

        public override string Texture { get { return "Sprites/bulOrb"; } }

        public override int Layer { get { return 11; } }

        public override float Size { get { return 32; } }

        //*
        public override void DrawEntity(GameTime gameTime)
        {
            DrawAnimation(anim, curColor, false, true);
        }//*/

        public override void OnStart()
        {
            //*
            Stage.EnqueueCommandSecs(2, delegate()
            {
                RedSpeed();
            });//*/
        }

        QueuedCommand theCommand = null;
        private float SpeedWait
        {
            get { return 2 * (1 / SpeedChange); }
        }

        private const float SpeedChange = 0.5f;

        protected void RedSpeed()
        {
            if (Deleted) return;
            curColor = RedColor;
            Velocity *= SpeedChange;

            theCommand = Stage.EnqueueCommandSecs(SpeedWait, delegate()
            {
                WhiteSpeed();
            });
        }

        protected void WhiteSpeed()
        {
            if (Deleted) return;
            curColor = Color.White;
            Velocity /= SpeedChange;

            theCommand = Stage.EnqueueCommandSecs(SpeedWait, delegate()
            {
                RedSpeed();
            });
        }

        protected override void OnRemove()
        {
            theCommand.Cancel();
        }
    }
}
