﻿using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using VillainmadEngine;

namespace Villainmad.Stages
{
    class PauseMenu : Menu
    {
        private class MenuContinue : IMenuItem
        {
            public void Select()
            {
                Menu.Close();
            }

            private static Vector2 position = new Vector2(320, 160);

            public void Draw(int Frame, bool Selected)
            {
                Drawing.DrawArbitraryString("CONTINUE", position, true,
                    (Selected) ? Color.White : Color.Gray);
            }
        }

        private class MenuClose : IMenuItem
        {
            public void Select()
            {
                Basis.Exit();
            }

            private static Vector2 position = new Vector2(320, 200);

            public void Draw(int Frame, bool Selected)
            {
                Drawing.DrawArbitraryString("EXIT", position, true,
                    (Selected) ? Color.White : Color.Gray);
            }
        }

        public PauseMenu()
            //: base(true)
        {
            ItemList.Add(new MenuContinue());
            ItemList.Add(new MenuClose());
            Sound.BGMPause();
        }
        private static Color bgColor = new Color(0f, 0f, 0f, 0.5f);

        public override void DrawBackground(GameTime gameTime)
        {
            Drawing.DrawRectangle(Stage.Active.GameArea, bgColor);
        }

        public override void OnExit()
        {
            Sound.BGMPlay();
        }
    }
}
