﻿using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using VillainmadEngine;

namespace Villainmad.Stages
{
    class PlayerLexy : PlayerCharacter
    {
        private byte Xpos = 2;
        private bool Focused = false;
        public override float Speed
        {
            get
            {
                return (Focused) ? 1.25F : 4;
            }
        }

        private string[] curImg = new string[]
            {"Sprites/LexyLeft2", "Sprites/LexyLeft1", 
                "Sprites/LexyNeutral",
                "Sprites/LexyRight1", "Sprites/LexyRight2"};

        public override void DrawEntity(GameTime gameTime)
        {
            Draw(curImg[Xpos], Color.White, true);
            if (Focused)
                Draw("Sprites/hitbox", Color.White, true);
        }

        protected override void Input(GameInput InputList, 
            GameInput InputPressed, GameInput InputReleased)
        {
            byte swing = 1;
            if ((InputList & GameInput.DLeft) != 0) swing = 0;
            else if ((InputList & GameInput.DRight) != 0) swing = 2;
            if (swing == 2 && Xpos < 4) Xpos++;
            else if (swing == 0 && Xpos > 0) Xpos--;
            else if (swing == 1)
            {
                if (Xpos > 2) Xpos--;
                if (Xpos < 2) Xpos++;
            }
            Focused = (InputList & GameInput.Focus) != 0;

            base.Input(InputList, InputPressed, InputReleased);
        }
    }
}
