﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;

namespace VillainmadEngine
{
    public partial class Basis
    {
        private int MinMenu = -1;
        #region Update
        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected sealed override void Update(GameTime gameTime)
        {
            CurrentInput.GetInput();

            if (ActiveState != null)
            {
                MinMenu = -1;
                if (ActiveMenu != null)
                {
                    for (int i = MenuList.Count - 1;
                        i >= 0 && MinMenu == -1; i--)
                    {
                        if (MenuList[i].HasSnapshot)
                            MinMenu = i;
                    }
                    ActiveMenu.Update(gameTime);
                }
                else
                {
                    ActiveState.Update(gameTime);
                    if (ActiveStage != null) ActiveStage.Update(gameTime);
                }
            }

            base.Update(gameTime);
        }
        #endregion

        #region Game Draw
        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override sealed void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Color.Black);

            DataStealer.IsDrawing = true;
            DataStealer.blendState = Drawing.DefaultBlend;

            DataStealer.StartBatch();

            if (ActiveState != null)
            {

                if (ActiveMenu != null || MinMenu == -1)
                {
                    ActiveState.DrawBackground(gameTime);
                    if (ActiveStage != null) ActiveStage.Draw(gameTime);
                }

                for (int i = MinMenu; i < MenuList.Count; i++)
                {
                    if (i == -1) continue;
                    MenuList[i].Draw(gameTime);
                }

                ActiveState.DrawForeground(gameTime);
            }

            spriteBatch.End();
            base.Draw(gameTime);
            DataStealer.IsDrawing = false;
        }
        #endregion
    }
}

