﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Configuration;
using Microsoft.Xna.Framework.Input;

namespace VillainmadEngine.Configuration
{
    internal partial class ConfigForm : Form
    {
        public ConfigForm()
        {
            InitializeComponent();
            comboResolution.DataSource = ScreenResolution.Resolutions;
        }

        private void ConfigForm_Load(object sender, EventArgs e)
        {
            Config.Load();
            LoadSettings();
        }

        private void LoadSettings()
        {
            comboResolution.SelectedIndex = Config.ScreenRes;

            if ((int)(Config.Deadzone * 100) < trackDead.Minimum
                || (int)(Config.Deadzone * 100) > trackDead.Maximum)
                Config.Deadzone = Config.Default.Deadzone;
            trackDead.Value = (int)(Config.Deadzone * 100);
        }

        private void btnOk_Click(object sender, EventArgs e)
        {
            Config.Save();
            this.Close();
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void btnDefault_Click(object sender, EventArgs e)
        {
            Config.Reset();
            LoadSettings();
        }

        private void trackDead_ValueChanged(object sender, EventArgs e)
        {
            float value = (float)(trackDead.Value) / 100;
            lblDead.Text = "Deadzone: " + String.Format("{0:0.00}", value);
            Config.Deadzone = value;
        }

        private void trackDead_Scroll(object sender, EventArgs e)
        {
            trackDead_ValueChanged(sender, e);
        }

        private void comboResolution_SelectedIndexChanged(object sender, EventArgs e)
        {
            Config.ScreenRes = comboResolution.SelectedIndex;
        }
    }
}
