﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace VillainmadEngine
{
    public static partial class Drawing
    {
        /// <summary>
        /// Default SpriteFont.
        /// </summary>
        private static SpriteFont defaultFont
        {
            get { return DataStealer.DefaultFont; }
        }

        #region DrawArbitrary: string, position, color
        /// <summary>
        /// Draws arbitrary text. Can only use ASCII alphanumeric text, no unicode.
        /// </summary>
        /// <param name="text">The text string to draw.</param>
        /// <param name="position">The position of the upper-left corner of the string.</param>
        /// <param name="color">The color to tint the text.</param>
        public static void DrawArbitraryString(string text, Vector2 position, Color color)
        {
            DrawArbitraryString(text, position, false, color);
        }
        #endregion

        /// <summary>
        /// Draws arbitrary text. Can only use ASCII alphanumeric text, no unicode.
        /// </summary>
        /// <param name="text">The text string to draw.</param>
        /// <param name="position">The position of the string.</param>
        /// <param name="origin">If true, the position will be located at the
        /// center of the string. If false, the position will be located at the
        /// upper-left corner of the string.</param>
        /// <param name="color">The color to tint the text.</param>
        public static void DrawArbitraryString(string text, Vector2 position, 
            bool origin, Color color)
        {
            Vector2 OriginPos = (origin) ? 
                defaultFont.MeasureString(text) / 2 : Vector2.Zero;
            spriteBatch.DrawString(defaultFont, text, position - OriginPos, color);
        }
    }
}
