﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace VillainmadEngine
{
    public partial class GameEntity
    {
        /// <summary>
        /// The layer the Entity will spawn in.
        /// </summary>
        public virtual int Layer
        {
            get { throw new NotImplementedException("Default Layer needed!"); }
        }

        /// <summary>
        /// The texture used by the game entity.
        /// </summary>
        public virtual string Texture
        {
            get { throw new NotImplementedException("Texture needed!"); }
        }

        /// <summary>
        /// The blendstate of the game entity.
        /// </summary>
        public virtual BlendState BlendState
        {
            get { return Drawing.DefaultBlend; }
        }

        /// <summary>
        /// If not negative, the entity deletes itself when its Age is greater than
        /// this point.
        /// </summary>
        public virtual int MaxAge
        {
            get { return -1; }
        }

        /// <summary>
        /// If positive, the entity deletes itself when it is this far off the
        /// screen. This should be greater than the size of the object's appearance,
        /// so that it doesn't abruptly vanish.
        /// </summary>
        public virtual float Size
        {
            get { return -1f; }
        }
    }
}
