﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;

namespace VillainmadEngine
{
    /// <summary>
    /// A state of the game, which can govern global variables.
    /// </summary>
    public partial class GameState : INDrawUpdateInput
    {
        /// <summary>
        /// The currently-active GameState.
        /// </summary>
        public static GameState Active
        {
            get { return DataStealer.ActiveGameState; }
        }

        /// <summary>
        /// Creates a new GameState.
        /// </summary>
        public GameState()
        {
        }

        /// <summary>
        /// Called whenever the game state should be updated.
        /// </summary>
        /// <param name="gameTime">Current elapsed gametime.</param>
        public override sealed void Update(GameTime gameTime)
        {
            Input();

            OnUpdate(gameTime);
        }
    }
}
