﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace VillainmadEngine
{
    public partial class INCommandUser
    {

        /// <summary>
        /// Carries out input and executes current list of commands.
        /// </summary>
        protected void DoCommands()
        {
            if (MaxFrame >= 0 && _frame >= MaxFrame) ResetFrame();
            else _frame++;

            Input();

            for (int i = 0; i < CommandList.Count; i++)
            {
                do
                {
                    QueuedCommand curCommand = CommandList[i];
                    if (!curCommand.Attention(Frame)) continue;
                    //*
                    if (curCommand.Cancelled)
                    {
                        CommandList.Remove(curCommand);
                        continue;
                    }//*/

                    if (curCommand.TargetFrame <= Frame)
                    {
                        curCommand.Act();
                        CommandList.Remove(curCommand);
                        continue;
                    }
                }
                while (i < CommandList.Count && CommandList[i].Attention(Frame));
            }
        }

        /// <summary>
        /// List of all current commands.
        /// </summary>
        public QueuedCommand[] Commands
        {
            get { return CommandList.ToArray(); }
        }
    }
}
