﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace VillainmadEngine
{
    public partial class INCommandUser
    {
        private int _frame = -1;
        /// <summary>
        /// The current frame of action.
        /// </summary>
        public int Frame
        {
            get
            {
                if (_frame < 0) return 0;
                else return _frame;
            }
        }

        /// <summary>
        /// If positive, specifies the maximum amount the frame can go before it will
        /// reset to zero.
        /// </summary>
        public virtual int MaxFrame
        {
            get { return -1; }
        }

        /// <summary>
        /// Resets the frame number back to zero, updating any queued commands in the 
        /// process.
        /// </summary>
        protected void ResetFrame()
        {
            foreach (QueuedCommand commandQ in CommandList)
            {
                commandQ.TargetFrame -= _frame;
            }
            _frame = 0;
        }
    }
}
