﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;

namespace VillainmadEngine
{
    /// <summary>
    /// Base for Menus, GameStates, and Stages.
    /// </summary>
    public partial class INDrawUpdateInput
    {
        /// <summary>
        /// Called whenever the component needs to update
        /// itself.
        /// Default does nothing.
        /// </summary>
        /// <param name="gameTime">Current elapsed gametime.</param>
        public virtual void Update(GameTime gameTime)
        {
        }

        /// <summary>
        /// Called at the end of every update. 
        /// Default does nothing.
        /// </summary>
        /// <param name="gameTime">Current elapsed gametime.</param>
        public virtual void OnUpdate(GameTime gameTime)
        {
        }

        /// <summary>
        /// Drawn behind mandatory elements.
        /// Default does nothing.
        /// </summary>
        /// <param name="gameTime"></param>
        public virtual void DrawBackground(GameTime gameTime)
        {
        }

        /// <summary>
        /// Drawn in front of mandatory elements.
        /// Default does nothing.
        /// </summary>
        /// <param name="gameTime"></param>
        public virtual void DrawForeground(GameTime gameTime)
        {
        }
    }
}
