﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace VillainmadEngine
{
    /// <summary>
    /// Individual items on a menu.
    /// </summary>
    public interface IMenuItem
    {
        /// <summary>
        /// Draws the given menu-item.
        /// </summary>
        /// <param name="frame">The current frame in the menu.</param>
        /// <param name="selected">True if the menu-item has been currently 
        /// selected.</param>
        void Draw(int frame, bool selected);

        /// <summary>
        /// Called when the menu-item is selected.
        /// </summary>
        void Select();
    }
}
