﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace VillainmadEngine
{
    /// <summary>
    /// <para>A game-menu, which can perform various functions.</para>
    /// <para>WARNING: Menus do not load their own textures, sounds, etc. You will have
    /// to do that in the stage or the gamestate.</para>
    /// </summary>
    public partial class Menu
        : INCommandUser
    {
        /// <summary>
        /// The currently-active menu.
        /// </summary>
        public static Menu Active
        {
            get { return DataStealer.ActiveMenu; }
        }

        /// <summary>
        /// Creates a new instance of a menu.
        /// </summary>
        public Menu()
#if HIDEF
            : this(false)
#endif
        {
        }
#if HIDEF
        /// <summary>
        /// Creates a new instance of a menu.
        /// </summary>
        /// <param name="Background">If true, takes a screenshot 
        /// and uses it as the background.</param>
        public Menu(bool Background)
        {
            if (Background) this.background = DataStealer.Screenshot();
        }
#endif

        /// <summary>
        /// Called when the menu needs to update itself.
        /// </summary>
        /// <param name="gameTime">Current elapsed gametime.</param>
        public override void Update(GameTime gameTime)
        {
            DoCommands();
        }
    }
}
