﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace VillainmadEngine
{
    public partial class Menu
    {
        /// <summary>
        /// Disposes of the entity's managed and unmanaged resources.
        /// </summary>
        public new void Dispose()
        {
            _Dispose(true);
            Dispose(true);
            base.Dispose();
        }

        /// <summary>
        /// Disposes of unmanaged resources, and optionally
        /// disposes of managed resources.
        /// </summary>
        /// <param name="disposing">True to dispose of managed resources,
        /// false otherwise.</param>
        private void _Dispose(bool disposing)
        {
            if (disposing)
            {
                if (this.background != null) background.Dispose();
                this._selected = 0;
                this.ItemList = new List<IMenuItem>();
            }
        }

        /// <summary>
        /// Destructor.
        /// </summary>
        ~Menu()
        {
            _Dispose(false);
            Dispose(false);
        }
    }
}
