﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace VillainmadEngine
{
    public partial class Menu
    {
        private Texture2D background = null;

        /// <summary>
        /// True if the menu has a snapshot; false otherwise.
        /// </summary>
        public bool HasSnapshot
        {
            get { return background == null; }
        }

        /// <summary>
        /// Called to draw the menu.
        /// </summary>
        /// <param name="gameTime">Current elapsed gametime.</param>
        public void Draw(GameTime gameTime)
        {
            if (background != null)
                DataStealer.SpriteBatch.Draw(background, Vector2.Zero, Color.White);

            DrawBackground(gameTime);

            for (int i = 0; i < ItemList.Count; i++)
            {
                ItemList[i].Draw(Frame, Selected == i);
            }

            DrawForeground(gameTime);
        }
    }
}
