﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace VillainmadEngine
{
    public partial class Menu
    {
        private int _selected = 0;

        /// <summary>
        /// Index of the currently-selected menu.
        /// </summary>
        public int Selected
        {
            get { return _selected; }
            set
            {
                if (value >= ItemList.Count) _selected = 0;
                else if (value < 0) _selected = ItemList.Count - 1;
                else _selected = value;
            }
        }

        /// <summary>
        /// Returns currently-selected menu-item.
        /// </summary>
        public IMenuItem CurrentItem
        {
            get { return ItemList[Selected];  }
        }

        /// <summary>
        /// List of menu-items used by this menu. Initialize this in the constructor.
        /// </summary>
        public List<IMenuItem> ItemList = new List<IMenuItem>();

        /// <summary>
        /// Automatically selects the currently-selected menu-item.
        /// </summary>
        public void SelectCurrent()
        {
            CurrentItem.Select();
        }
    }
}
