﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;

namespace VillainmadEngine
{
    /// <summary>
    /// Controls for sound-instances.
    /// </summary>
    public static partial class Sound
    {
        private static byte _step = 0;
        /// <summary>
        /// Called every frame to remove unused sounds, etc.
        /// </summary>
        public static void Update()
        {
            List<int> Remove = new List<int>();
            for (int i = 0; i < SoundList.Count; i++)
            {
                if (SoundList[i].State == SoundState.Stopped) Remove.Add(i);
            }
            if (_step == 10)
            {
                _step = 0;

                foreach (AudioEngine curEng in DataStealer.AudioEngineList.Values)
                    curEng.Update();
            }
            else _step++;
        }

        private static void SoundEffectCheck(string filename)
        {
            if (filename == null) throw new ArgumentNullException();
            if (!DataStealer.SoundEffectList.ContainsKey(filename))
                throw new ArgumentException("Sound effect " + filename +
            "not loaded.");
        }
    }
}
