﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace VillainmadEngine
{
    /// <summary>
    /// Represents a game-stage.
    /// </summary>
    public partial class Stage
        : INCommandUser
    {
        /// <summary>
        /// The currently-active Stage.
        /// </summary>
        public static Stage Active
        {
            get { return DataStealer.ActiveStage; }
        }

        /// <summary>
        /// Creates a new Stage instance.
        /// </summary>
        public Stage()
        {
            EntityArray = new List<GameEntity>[NumLayers];
            for (int i = 0; i < EntityArray.Length; i++)
                EntityArray[i] = new List<GameEntity>();

            float mult = DataStealer.curRes.Multiplier;

            _rect = new Rectangle((int)((GameArea.X * mult) 
                + DataStealer.DefaultViewport.X),
                (int)(GameArea.Y * mult), 
                (int)(GameArea.Width * mult), 
                (int)(GameArea.Height * mult));
            _viewport = new Viewport(_rect);
        }

        private Rectangle _rect;
        private Viewport _viewport;
    }
}
