﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.Input;
using Nuclex.Input;
using Nuclex.Input.Devices;

namespace VillainmadEngine
{
    /// <summary>
    /// The game's allowed inputs, labelled with defaults.
    /// </summary>
    [Flags]
    public enum GameInput
    {
        /// <summary>
        /// Primary attack
        /// </summary>
        Fire1 = 0x01,
        /// <summary>
        /// Secondary attack
        /// </summary>
        Fire2 = 0x0002,
        /// <summary>
        /// Tertiary attack
        /// </summary>
        Fire3 = 0x0004,
        /// <summary>
        /// Enter, next
        /// </summary>
        Enter = 0x0008,
        /// <summary>
        /// Escape, cancel
        /// </summary>
        Esc = 0x0010,
        /// <summary>
        /// Control movement further
        /// </summary>
        Focus = 0x0020,
        /// <summary>
        /// Skip dialogue
        /// </summary>
        Skip = 0x0040,
        /// <summary>
        /// Directional Up
        /// </summary>
        DUp = 0x0080,
        /// <summary>
        /// Directional Right
        /// </summary>
        DRight = 0x0100,
        /// <summary>
        /// Directional Down
        /// </summary>
        DDown = 0x0200,
        /// <summary>
        /// Directional Left
        /// </summary>
        DLeft = 0x0400
    }
}
