﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Audio;

namespace VillainmadEngine
{
    /// <summary>
    /// Object-references for all the various things which will be publicly available
    /// from the Basis.
    /// </summary>
    internal static partial class DataStealer
    {
        public static bool IsDrawing = false;
        public static Basis Basis;
        public static SpriteBatch SpriteBatch;

        private static Type _default;

        public static Type DefaultType
        {
            get { return _default; }
            set
            {
                if (!value.IsSubclassOf(typeof(GameState)))
                    throw new ArgumentException("Must be a State!");

                _default = value;
            }
        }

        public static Dictionary<string, Texture2D> Texture2DList = 
            new Dictionary<string,Texture2D>();
        public static string[] Texture2DGS = new string[] { };
        public static string[] Texture2DStage = new string[] { };

        public static Dictionary<string, SoundEffect> SoundEffectList =
            new Dictionary<string, SoundEffect>();
        public static string[] SoundEffectGS = new string[] { };
        public static string[] SoundEffectStage = new string[] { };

        public static Dictionary<string, AudioEngine> AudioEngineList =
            new Dictionary<string, AudioEngine>();
        public static string AudioEngineGS = null;
        public static string AudioEngineStage = null;

        public static Dictionary<string, SoundBank> SoundBankList =
            new Dictionary<string, SoundBank>();
        public static string SoundBankGS = null;
        public static string SoundBankStage = null;

        public static Dictionary<string,WaveBank> WaveBankList =
            new Dictionary<string,WaveBank>();
        public static string WaveBankGS = null;
        public static string WaveBankStage = null;

        public static SpriteFont DefaultFont;
    }
}
