﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;

namespace VillainmadEngine
{
    internal static partial class DataStealer
    {
        public static ContentManager Content
        {
            get { return Basis.Content; }
        }

        /*
        /// <summary>
        /// <para>So, here's the plan:</para>
        /// <para>If the new item is a STATE, it unloads all resources which are
        /// not in the new one, and adds its resources to the State-list.</para>
        /// <para>If it is a STAGE, it unloads all menu-specific resources which
        /// are not also State resources.</para>
        /// <para>If it is any other, it will also add its own resources to the
        /// list of Menu resources.</para>
        /// </summary>
        /// <param name="NewItem"></param>
        public static void CompareLoad(IContentLoader NewItem)
        {
            NewItem.LoadBegin();
            List<string> Texture2DNew = new List<string>();
            List<string> SoundEffectNew = new List<string>();

            if (NewItem.GetType().IsSubclassOf(typeof(GameState)))
            {
                #region Texture2D - State
                List<string> Removes = new List<string>();
                Texture2DStage = new List<string>();
                foreach (string curString in Texture2DList.Keys)
                    if (!NewItem.Texture2DList.Contains(curString))
                        Removes.Add(curString);

                foreach (string curString in Removes)
                {
                    Texture2DGS.Remove(curString);
                    Texture2D curItem = Texture2DList[curString];
                    Texture2DList.Remove(curString);
                    curItem.Dispose();
                }

                foreach (string curString in NewItem.Texture2DList)
                    if (!Texture2DGS.Contains(curString))
                    {
                        Texture2DGS.Add(curString);
                        Texture2DNew.Add(curString);
                    }
                #endregion

                #region SoundEffect - State
                SoundEffectStage = new List<string>();
                Removes = new List<string>();
                foreach (string curString in SoundEffectList.Keys)
                    if (!NewItem.SoundEffectList.Contains(curString))
                        Removes.Add(curString);

                foreach (string curString in Removes)
                {
                    SoundEffectGS.Remove(curString);
                    SoundEffect curItem = SoundEffectList[curString];
                    SoundEffectList.Remove(curString);
                    curItem.Dispose();
                }

                foreach (string curString in NewItem.SoundEffectList)
                    if (!SoundEffectGS.Contains(curString))
                    {
                        SoundEffectGS.Add(curString);
                        SoundEffectNew.Add(curString);
                    }

                #endregion

                #region Xact - State
                AudioEngineStage = null;
                SoundBankStage = null;
                WaveBankStage = null;
                #region AudioEngine
                Removes = new List<string>();
                foreach (string curString in AudioEngineList.Keys)
                    if (NewItem.AudioEngine != curString)
                        Removes.Add(curString);
                
                foreach (string curString in Removes)
                {
                    AudioEngine curItem = AudioEngineList[curString];
                    AudioEngineList.Remove(curString);
                    curItem.Dispose();
                }
                #endregion

                #region SoundBank
                Removes = new List<string>();
                foreach (string curString in SoundBankList.Keys)
                    if (NewItem.SoundBank != curString)
                        Removes.Add(curString);

                foreach (string curString in Removes)
                {
                    SoundBank curItem = SoundBankList[curString];
                    SoundBankList.Remove(curString);
                    curItem.Dispose();
                }
                #endregion

                #region WaveBank
                Removes = new List<string>();
                foreach (string curString in WaveBankList.Keys)
                    if (NewItem.WaveBank != curString)
                        Removes.Add(curString);

                foreach (string curString in Removes)
                {
                    WaveBank curItem = WaveBankList[curString];
                    WaveBankList.Remove(curString);
                    curItem.Dispose();
                }
                #endregion

                if (NewItem.AudioEngine != null && NewItem.SoundBank != null
                    && NewItem.WaveBank != null)
                {
                    #region Produce new
                    AudioEngineGS = NewItem.AudioEngine;
                    SoundBankGS = NewItem.SoundBank;
                    WaveBankGS = NewItem.WaveBank;
                    #endregion
                }
                else
                {
                    #region Dispose Of Old
                    if (AudioEngineGS != null)
                    {
                        if (AudioEngineList.ContainsKey(AudioEngineGS))
                        {
                            AudioEngine curItem = AudioEngineList[AudioEngineGS];
                            AudioEngineList.Remove(AudioEngineGS);
                            curItem.Dispose();
                        }
                        AudioEngineGS = null;
                    }
                    if (SoundBankGS != null)
                    {
                        if (SoundBankList.ContainsKey(SoundBankGS))
                        {
                            SoundBank curItem = SoundBankList[SoundBankGS];
                            SoundBankList.Remove(SoundBankGS);
                            curItem.Dispose();
                        }
                        SoundBankGS = null;
                    }

                    if (WaveBankGS != null)
                    {
                        if (WaveBankList.ContainsKey(WaveBankGS))
                        {
                            WaveBank curItem = WaveBankList[WaveBankGS];
                            SoundBankList.Remove(WaveBankGS);
                            curItem.Dispose();
                        }
                        WaveBankGS = null;
                    }
                    #endregion
                }
                #endregion
            }
            else if (NewItem.GetType().IsSubclassOf(typeof(Stage)))
            {
                #region Texture2D - Stage
                List<string> Removes = new List<string>();
                foreach (string curString in Texture2DStage)
                    if (!Texture2DGS.Contains(curString)
                        && !NewItem.Texture2DList.Contains(curString))
                        Removes.Add(curString);

                foreach (string curString in Removes)
                {
                    Texture2DStage.Remove(curString);
                    Texture2D curItem = Texture2DList[curString];
                    Texture2DList.Remove(curString);
                    curItem.Dispose();
                }

                foreach (string curString in NewItem.Texture2DList)
                    if (!Texture2DList.Keys.Contains(curString))
                    {
                        Texture2DStage.Add(curString);
                        Texture2DNew.Add(curString);
                    }
                #endregion

                #region SoundEffect - Stage
                Removes = new List<string>();
                foreach (string curString in SoundEffectStage)
                    if (!SoundEffectGS.Contains(curString)
                        && !NewItem.SoundEffectList.Contains(curString))
                        Removes.Add(curString);

                foreach (string curString in Removes)
                {
                    SoundEffectStage.Remove(curString);
                    SoundEffect curItem = SoundEffectList[curString];
                    SoundEffectList.Remove(curString);
                    curItem.Dispose();
                }

                foreach (string curString in NewItem.SoundEffectList)
                    if (!SoundEffectList.Keys.Contains(curString))
                    {
                        SoundEffectStage.Add(curString);
                        SoundEffectNew.Add(curString);
                    }
                #endregion

                #region Xact - Stage
                Removes = null;
                #region AudioEngine
                if (AudioEngineGS != AudioEngineStage &&
                    AudioEngineStage != NewItem.AudioEngine)
                {
                    AudioEngine curItem = AudioEngineList[AudioEngineStage];
                    AudioEngineList.Remove(AudioEngineStage);
                    curItem.Dispose();
                }
                #endregion

                #region SoundBank
                if (SoundBankGS != SoundBankStage &&
                    SoundBankStage != NewItem.SoundBank)
                {
                    SoundBank curItem = SoundBankList[AudioEngineStage];
                    SoundBankList.Remove(SoundBankStage);
                    curItem.Dispose();
                }
                #endregion

                #region WaveBank
                if (SoundBankGS != SoundBankStage &&
                    SoundBankStage != NewItem.SoundBank)
                {
                    SoundBank curItem = SoundBankList[AudioEngineStage];
                    SoundBankList.Remove(SoundBankStage);
                    curItem.Dispose();
                }
                #endregion

                if (NewItem.AudioEngine != null && NewItem.SoundBank != null
                    && NewItem.WaveBank != null)
                {
                    #region Produce New
                    AudioEngineStage = NewItem.AudioEngine;
                    SoundBankStage = NewItem.SoundBank;
                    WaveBankStage = NewItem.WaveBank;
                    #endregion
                }
                else
                {
                    #region Dispose Of Old
                    if (AudioEngineStage != null)
                    {
                        if (AudioEngineList.ContainsKey(AudioEngineStage))
                        {
                            AudioEngine curItem = AudioEngineList[AudioEngineStage];
                            AudioEngineList.Remove(AudioEngineStage);
                            curItem.Dispose();
                        }
                        AudioEngineStage = null;
                    }
                    if (SoundBankStage != null)
                    {
                        if (SoundBankList.ContainsKey(SoundBankStage))
                        {
                            SoundBank curItem = SoundBankList[SoundBankStage];
                            SoundBankList.Remove(SoundBankStage);
                            curItem.Dispose();
                        }
                        SoundBankStage = null;
                    }

                    if (WaveBankStage != null)
                    {
                        if (WaveBankList.ContainsKey(WaveBankStage))
                        {
                            WaveBank curItem = WaveBankList[WaveBankStage];
                            SoundBankList.Remove(WaveBankStage);
                            curItem.Dispose();
                        }
                        WaveBankStage = null;
                    }
                    #endregion
                }
                #endregion
            }
            else throw new InvalidProgramException();

            #region Texture2D - Load
            List<string> NewList = NewItem.Texture2DList.ToList();
            foreach (string curString in Texture2DList.Keys)
                NewList.Remove(curString);

            for (int i = 0; i < NewList.Count; i++)
            {
                Texture2DList.Add(NewList[i],
                    Basis.Content.Load<Texture2D>("gfx/" + NewList[i]));
            }
            #endregion

            #region SoundEffect - Load
            NewList = NewItem.SoundEffectList.ToList();
            foreach (KeyValuePair<string, SoundEffect> curKVP in SoundEffectList)
                if (NewList.Contains(curKVP.Key)) NewList.Remove(curKVP.Key);

            for (int i = 0; i < NewList.Count; i++)
            {
                SoundEffect effect = Basis.Content.Load<SoundEffect>("sfx/" + NewList[i]);
                effect.Name = NewList[i];
                SoundEffectList.Add(NewList[i], effect);
            }
            #endregion

            #region Xact - Load
            if (NewItem.AudioEngine != null && NewItem.SoundBank != null
                && NewItem.WaveBank != null)
            {
                AudioEngine engine = new AudioEngine("Content\\sfx\\" +
                    NewItem.AudioEngine + ".xgs");
                SoundBank soundBank = new SoundBank(engine, "Content\\sfx\\" +
                    NewItem.SoundBank + ".xsb");
                WaveBank waveBank = new WaveBank(engine, "Content\\sfx\\" +
                    NewItem.WaveBank + ".xwb");

                AudioEngineList.Add(NewItem.AudioEngine, engine);
                SoundBankList.Add(NewItem.SoundBank, soundBank);
                WaveBankList.Add(NewItem.WaveBank, waveBank);
            }
            #endregion
        }//*/

        public static void LoadGameState(GameState NewState)
        {
            NewState.LoadBegin();

            Texture2DGS = NewState.Texture2DList;
            SoundEffectGS = NewState.SoundEffectList;
            AudioEngineGS = NewState.AudioEngine;
            SoundBankGS = NewState.SoundBank;
            WaveBankGS = NewState.WaveBank;

            //DELETE EVERYTHING NOT THERE!
            UnloadUnnecessary();
            //Load New!
            LoadNew(NewState);

            NewState.LoadEnd();
        }

        public static void LoadStage(Stage NewStage)
        {
            Texture2DStage = NewStage.Texture2DList;
            SoundEffectStage = NewStage.SoundEffectList;
            AudioEngineStage = NewStage.AudioEngine;
            SoundBankStage = NewStage.SoundBank;
            WaveBankStage = NewStage.WaveBank;

            //DELETE EVERYTHING NOT THERE!
            UnloadUnnecessary();

            LoadNew(NewStage);
        }

        private static void LoadNew(IContentLoader NewItem)
        {
            foreach (string curName in NewItem.Texture2DList)
            {
                if (!DataStealer.Texture2DList.ContainsKey(curName))
                {
                    Texture2D curItem
                        = Content.Load<Texture2D>("gfx\\" + curName);
                    Texture2DList.Add(curName, curItem);
                }
            }
            foreach (string curName in NewItem.SoundEffectList)
            {
                if (!DataStealer.SoundEffectList.ContainsKey(curName))
                {
                    SoundEffect curItem
                        = Content.Load<SoundEffect>("sfx\\" + curName);
                    curItem.Name = curName;
                    SoundEffectList.Add(curName, curItem);
                }
            }
            if (NewItem.AudioEngine != null && NewItem.SoundBank != null
                && NewItem.WaveBank != null
                && !AudioEngineList.ContainsKey(NewItem.AudioEngine)
                && !SoundBankList.ContainsKey(NewItem.SoundBank)
                && !WaveBankList.ContainsKey(NewItem.WaveBank))
            {
                AudioEngine engine = new AudioEngine("Content\\sfx\\" +
                    NewItem.AudioEngine + ".xgs");
                SoundBank soundBank = new SoundBank(engine, "Content\\sfx\\" +
                    NewItem.SoundBank + ".xsb");
                WaveBank waveBank = new WaveBank(engine, "Content\\sfx\\" +
                    NewItem.WaveBank + ".xwb");

                AudioEngineList.Add(NewItem.AudioEngine, engine);
                SoundBankList.Add(NewItem.SoundBank, soundBank);
                WaveBankList.Add(NewItem.WaveBank, waveBank);
            }
        }

        /// <summary>
        /// Unloads all content which is no longer a part of anything~
        /// </summary>
        public static void UnloadUnnecessary()
        {
            string[] keys = Texture2DList.Keys.ToArray();
            foreach (string curKey in keys)
            {
                if (!Texture2DGS.Contains(curKey) &&
                    !Texture2DStage.Contains(curKey))
                {
                    Texture2D curItem = Texture2DList[curKey];
                    Texture2DList.Remove(curKey);
                    curItem.Dispose();
                }
            }

            keys = SoundEffectList.Keys.ToArray();
            foreach (string curKey in keys)
            {
                if (!SoundEffectGS.Contains(curKey) &&
                    !SoundEffectStage.Contains(curKey))
                {
                    SoundEffect curItem = SoundEffectList[curKey];
                    SoundEffectList.Remove(curKey);
                    curItem.Dispose();
                }
            }

            keys = SoundBankList.Keys.ToArray();
            foreach (string curKey in keys)
            {
                if (SoundBankGS != curKey &&
                    SoundBankStage != curKey)
                {
                    SoundBank curItem = SoundBankList[curKey];
                    SoundBankList.Remove(curKey);
                    curItem.Dispose();
                }
            }

            keys = WaveBankList.Keys.ToArray();
            foreach (string curKey in keys)
            {
                if (WaveBankGS != curKey &&
                    WaveBankStage != curKey)
                {
                    WaveBank curItem = WaveBankList[curKey];
                    WaveBankList.Remove(curKey);
                    curItem.Dispose();
                }
            }

            keys = AudioEngineList.Keys.ToArray();
            foreach (string curKey in keys)
            {
                if (AudioEngineGS != curKey &&
                    AudioEngineStage != curKey)
                {
                    AudioEngine curItem = AudioEngineList[curKey];
                    AudioEngineList.Remove(curKey);
                    curItem.Dispose();
                }
            }
        }
    }
}
