﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using VillainmadEngine.Configuration;

namespace VillainmadEngine
{
    internal static partial class DataStealer
    {
        public static BlendState blendState;

        public static Matrix SpriteScale;

        public static Viewport DefaultViewport;

        public static ScreenResolution curRes;

        public static GraphicsDevice GraphicsDevice
        {
            get { return Basis.GraphicsDevice; }
        }

        public static void StartBatch(BlendState blendState)
        {
            SpriteBatch.Begin(SpriteSortMode.Deferred, blendState,
                SamplerState.LinearClamp, DepthStencilState.None,
                RasterizerState.CullCounterClockwise, null, DataStealer.SpriteScale);
        }

        public static void StartBatch()
        {
            StartBatch(Drawing.DefaultBlend);
        }
#if HIDEF
        /// <summary>
        /// Takes a screenshot.
        /// </summary>
        /// <returns>Returns a screenshot.</returns>
        public static Texture2D Screenshot()
        {
            GraphicsDevice device = DataStealer.Basis.GraphicsDevice;
            int width = device.PresentationParameters.BackBufferWidth;
            int height = device.PresentationParameters.BackBufferHeight;
            byte[] ScreenData = new Byte[width * height * 4];

            device.GetBackBufferData<byte>(ScreenData);

            return new Texture2D(device, width, height, false,
                device.PresentationParameters.BackBufferFormat);
        }
#endif
    }
}
